#include <sys/types.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>

struct sockaddr_in saddr;
struct hostent *hp;

fd_set fds,fds_fresh,fds_read,fds_write,fds_except;

int errno;


#include <fcntl.h>

int master, slave, i;

int newpty(){
   int j;
   char buf[100];
   strcpy (buf,"/dev/ptyyX");
for (j=1;j<26;j++) {
   buf[8] = 'p' + j;
   for (i=0;i<16;i++){
      buf[9] = "0123456789abcdef"[i];
      if (0 < (master = open(buf, O_RDWR))) {
         //fprintf(stdout,"%s",buf+8);
         //fprintf(stderr,"%s\n",buf);
         /*if(0 >  setsid()) perror("setsid");*/
         buf[5] = 't';
         if (0 < (slave = open(buf, O_RDWR))) {
            //fprintf(stdout,"%s",buf+8);
            //fprintf(stderr,"%s\n",buf);
            return master;
         }else{
            perror("slave pty");
         }
      }
   }
}
   fprintf(stderr,"no available pseudo tty");
   master = -1;
   return master;
}

fd_set fds,fds_fresh,fds_read,fds_write,fds_except;

char c;

main(argc,argv,envp)
   int argc;
   char *argv[];
   char *envp[];
{
   int s;
   int snew;
   char *buf = "xx";
   int p;

   int s1 = newpty();

   int me;
   if (fork()) me = 1;
   else if (fork()) me = 2;
   else me = 3;

   switch (me) {
   case 1: output_writer(); break;
   case 2: input_reader(); break;
   case 3: application(argv,envp); break;
   }
   exit(0);
}
input_reader(){
   close(slave);
   dup2(master,1);
   fprintf(stderr,"ir start\n");
   while (EOF != (c = getchar())) { 
      //fprintf(stderr,"ir %c\n",c);
      putchar(c); fflush(stdout);
   }
   fclose(stdout);
   fprintf(stderr,"ir done\n");
}

output_writer(){
   close(slave);
   dup2(master,0);
   fprintf(stderr,"ow start\n");
   while (EOF != (c = getchar())) { 
      //fprintf(stderr,"ow %c\n",c);
      putchar(c);
   }
   fprintf(stderr,"ow done\n");
}

application(char **argv, char **envp){
   int i;
   close(master);
   dup2(slave,0);
   dup2(slave,1);
   
   //fprintf(stderr,"ap start\n");
   //printf("hello from ap\n");;
   //printf("execve %s\n",argv[1],envp);
   i = execv(argv[1],argv+1,envp);
   if (i<0) perror("execl "),exit(1);
   fprintf(stderr,"ap done\n");
   exit(0);

   while (EOF != (c = getchar())) {
      fprintf(stderr,"ap %c\n",c);
      putchar(c);
   }
   exit (0);
}
